/******************************************************
STM8S003K3 16MHz, IAR1.4+STM8S_StdPeriph_Lib_V2.1.0
******************************************************/
#include "stm8s.h"
#include "iostm003.c"

#define A       PD_ODR_ODR7
#define B       PD_ODR_ODR6
#define C       PD_ODR_ODR5
#define D       PD_ODR_ODR4
#define E       PD_ODR_ODR3
#define F       PD_ODR_ODR2
#define G       PD_ODR_ODR1
#define DP      PC_ODR_ODR7
#define N0      PC_ODR_ODR6
#define N1      PC_ODR_ODR5
#define N2      PC_ODR_ODR4
#define N3      PC_ODR_ODR3

#define key	    PB_IDR_IDR7

#define HL	    PF_ODR_ODR4
#define HR	    PA_ODR_ODR3
#define LL	    PB_ODR_ODR4
#define LR	    PB_ODR_ODR5



volatile u8 cntfb;
u8 tmr0,tmr1;

void gpio_cfg()
{
  PA_DDR=PB_DDR=PC_DDR=PD_DDR=PE_DDR=PF_DDR=0xff; //conf as output
  PA_CR1=PB_CR1=PC_CR1=PD_CR1=PE_CR1=PF_CR1=0xff; //push-pull|pullup
  //PB_DDR_DDR2=PB_DDR_DDR3=PB_DDR_DDR7=0;//ADC2,3, PB7_IN
 // PB_CR1_C12=PB_CR1_C13=PB_CR1_C14=PB_CR1_C15=0;//pullup off 
  PD_DDR_DDR0=0; //BKIN
  PB_ODR_ODR0=PB_ODR_ODR1=PB_ODR_ODR3=1;

}
void clk_cfg()
{
  CLK_DeInit();
  CLK->CKDIVR = 0;
  CLK->PCKENR1 = 0x80; //only tim1&adc clk enabled
}
void t1_cfg()
{

  TIM1->ARRH  =1;
  TIM1->ARRL  =0xff;
  TIM1->CCR1H=TIM1->CCR2H=0;
  TIM1->CCR3H=TIM1->CCR4H=1;
  TIM1->CCR1L=TIM1->CCR2L=0;
  TIM1->CCR3L=TIM1->CCR4L=0xff;
  TIM1->CR1   = TIM1_COUNTERMODE_CENTERALIGNED1|TIM1_CR1_ARPE|TIM1_CR1_URS;
  TIM1->CR2   = TIM1_CR2_CCPC;
  TIM1->RCR	  = 1;
  TIM1->IER   = TIM1_IER_UIE;

  TIM1->CCER1 = TIM1_CCER1_CC1E|TIM1_CCER1_CC1NE|TIM1_CCER1_CC1NP;
  TIM1->CCER1|= TIM1_CCER1_CC2E;
  TIM1->CCER2 = TIM1_CCER2_CC3E|TIM1_CCER2_CC3NE|TIM1_CCER2_CC3NP; 
  TIM1->CCER2|= TIM1_CCER2_CC4E;
  
  TIM1->CCMR1=TIM1->CCMR2 = TIM1_OCMODE_PWM1|TIM1_CCMR_OCxPE;
  TIM1->CCMR3=TIM1->CCMR4 = TIM1_OCMODE_PWM2|TIM1_CCMR_OCxPE;

  TIM1->EGR  |= TIM1_EGR_COMG; //update CCER reg with COM event

  TIM1->OISR = 0; //iddle state
  TIM1->BKR  = TIM1_BKR_OSSI|TIM1_BKR_MOE;
  TIM1->DTR  = 0x0f; //(62ns*x)
  TIM1->CR1 |= TIM1_CR1_CEN;
  TIM1->BKR |= TIM1_LOCKLEVEL_3;

}

INTERRUPT_HANDLER(TIM1_X3_Handler, 11)
{
#define s_step 156
#define dtv 4
static u8 c=0,d=1,a=1;
static u8 mst=0xff;
u8 tmp_table;

static const u8 s_table [s_step/2]=
{0,5,10,15,20,25,31,36,41,46,51,56,61,66,71,76,81,86,91,96,100,
105,110,115,119,124,128,133,137,141,146,150,154,158,162,166,170,174,178,181,185,189,
192,195,199,202,205,208,211,214,217,219,222,225,227,229,232,234,236,238,240,241,243,
245,246,247,249,250,251,252,253,253,254,254,255,255,255,255};

tmp_table=(u8)(((u16)s_table [c]*mst)>>8);

if(d)
 {
	if(tmp_table<0xff-dtv)
        {TIM1->CCR1L=TIM1->CCR2L=tmp_table;TIM1->CCR3L=TIM1->CCR4L=0xff-tmp_table;}
	else  {TIM1->CCR1L=TIM1->CCR2L=0xff-dtv;TIM1->CCR3L=TIM1->CCR4L=dtv;}

  	if(c<s_step/2-1){c++;} else {d=0;}
 }
else
  {
	if(tmp_table<0xff-dtv)
        {TIM1->CCR1L=TIM1->CCR2L=tmp_table;TIM1->CCR3L=TIM1->CCR4L=0xff-tmp_table;}
	else  {TIM1->CCR1L=TIM1->CCR2L=0xff-dtv;TIM1->CCR3L=TIM1->CCR4L=dtv;}

  	if(c){c--;}
	else
	{
	 d=1; a^=1;
	 if(a){HL=1;LL=0;HR=0;LR=1;}
	 else {HL=0;LL=1;HR=1;LR=0;}
	}
  }

  	TIM1->SR1 = 0;
}

void main()
{
gpio_cfg();
clk_cfg();
t1_cfg();



asm("rim");

while(1)
{

}
}





